--------------------------------------------------------------------------------
-- Copyright (c) 1995-2006 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 8.2.03i
--  \   \         Application : sch2vhdl
--  /   /         Filename : blokksema.vhf
-- /___/   /\     Timestamp : 11/17/2006 14:14:38
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: "H:\Program Files\XilinxIse82i3\bin\nt\sch2vhdl.exe" -intstyle ise -family spartan3 -flat -suppress -w G:/tmp/ise82/demo_a/blokksema.sch blokksema.vhf
--Design Name: blokksema
--Device: spartan3
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesis and simulted, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity blokksema is
   port ( clk50     : in    std_logic; 
          nyomogomb : in    std_logic; 
          rst       : in    std_logic; 
          digit     : out   std_logic_vector (3 downto 0); 
          led       : out   std_logic; 
          seg       : out   std_logic_vector (7 downto 0));
end blokksema;

architecture BEHAVIORAL of blokksema is
   signal ertek      : std_logic_vector (3 downto 0);
   signal mintavetel : std_logic;
   signal parancs    : std_logic_vector (1 downto 0);
   component fsm
      port ( clk50  : in    std_logic; 
             rst    : in    std_logic; 
             uzenet : in    std_logic_vector (1 downto 0); 
             led    : out   std_logic; 
             szam   : out   std_logic_vector (3 downto 0));
   end component;
   
   component prellment
      port ( gomb         : in    std_logic; 
             clk50        : in    std_logic; 
             rst          : in    std_logic; 
             x20msen      : in    std_logic; 
             gomb_esemeny : out   std_logic_vector (1 downto 0));
   end component;
   
   component dekad_kij
      port ( d     : in    std_logic_vector (3 downto 0); 
             digit : out   std_logic_vector (3 downto 0); 
             seg   : out   std_logic_vector (7 downto 0));
   end component;
   
   component oszto_20ms
      port ( clk50     : in    std_logic; 
             rst       : in    std_logic; 
             x20ms_out : out   std_logic);
   end component;
   
begin
   cpu : fsm
      port map (clk50=>clk50,
                rst=>rst,
                uzenet(1 downto 0)=>parancs(1 downto 0),
                led=>led,
                szam(3 downto 0)=>ertek(3 downto 0));
   
   gombkezelo : prellment
      port map (clk50=>clk50,
                gomb=>nyomogomb,
                rst=>rst,
                x20msen=>mintavetel,
                gomb_esemeny(1 downto 0)=>parancs(1 downto 0));
   
   kijelzo : dekad_kij
      port map (d(3 downto 0)=>ertek(3 downto 0),
                digit(3 downto 0)=>digit(3 downto 0),
                seg(7 downto 0)=>seg(7 downto 0));
   
   timer : oszto_20ms
      port map (clk50=>clk50,
                rst=>rst,
                x20ms_out=>mintavetel);
   
end BEHAVIORAL;


