-- Ksztette : Vgh Tams 2006.11.15.
-- 
--Tervezzen egy egyszer szmll ramkrt, amely egy nyomgomb (BTN0) 
--megnyomsnak hatsra nvel egy 4 bites szmot.  
--A nyomgomb megnyomsi idejt mrni kell (min. 500 ms) s prellmentesteni kell.


--Ez a modul a terv top level modulja, ez tulajdonkppen a strukturlt terv blokksmja
--VHDL kdban lerva.

--Ennek a mdszernek ugyanaz az elnye mint a rajzolt blokksms vltozatnak, azaz
--a modulok egymstl teljesen fggetlenl megtervezhetk, a programjuk megrhat, 
--tesztelhet s ms projektekben jrahasznosthat!

--Tovbbi elny, hogy a terv minden modulja tisztn VHDL kdban rdik, 
--ami biztostja a terv hordozhatsgt.



library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
--library UNISIM;
--use UNISIM.Vcomponents.ALL;

entity blokksema is
   port ( clk50     : in    std_logic; 
          nyomogomb : in    std_logic; 
          rst       : in    std_logic; 
          digit     : out   std_logic_vector (3 downto 0); 
          led       : out   std_logic; 
          seg       : out   std_logic_vector (7 downto 0));
end blokksema;

architecture BEHAVIORAL of blokksema is
   signal ertek      : std_logic_vector (3 downto 0);
   signal mintavetel : std_logic;
   signal parancs    : std_logic_vector (1 downto 0);
	
   component fsm
      port ( clk50  : in    std_logic; 
             rst    : in    std_logic; 
             uzenet : in    std_logic_vector (1 downto 0); 
             led    : out   std_logic; 
             szam   : out   std_logic_vector (3 downto 0));
   end component;
   
   component prellment
      port ( gomb         : in    std_logic; 
             clk50        : in    std_logic; 
             rst          : in    std_logic; 
             x20msen      : in    std_logic; 
             gomb_esemeny : out   std_logic_vector (1 downto 0));
   end component;
   
   component dekad_kij
      port ( d     : in    std_logic_vector (3 downto 0); 
             digit : out   std_logic_vector (3 downto 0); 
             seg   : out   std_logic_vector (7 downto 0));
   end component;



   
   component oszto_20ms
      port ( clk50     : in    std_logic; 
             rst       : in    std_logic; 
             x20ms_out : out   std_logic);
   end component;
   
begin
   cpu : fsm
      port map (clk50=>clk50,
                rst=>rst,
                uzenet(1 downto 0)=>parancs(1 downto 0),
                led=>led,
                szam(3 downto 0)=>ertek(3 downto 0));
   
   gombkezelo : prellment
      port map (clk50=>clk50,
                gomb=>nyomogomb,
                rst=>rst,
                x20msen=>mintavetel,
                gomb_esemeny(1 downto 0)=>parancs(1 downto 0));
   
   kijelzo : dekad_kij
      port map (d(3 downto 0)=>ertek(3 downto 0),
                digit(3 downto 0)=>digit(3 downto 0),
                seg(7 downto 0)=>seg(7 downto 0));
   
   timer : oszto_20ms
      port map (clk50=>clk50,
                rst=>rst,
                x20ms_out=>mintavetel);
   
end BEHAVIORAL;


