-- Ksztette : Hegedus Zoltan 2008.10.05.
-- egy dekdos hexa kijelz 

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity dekad_kij is
    Port (
			clk50 : in std_logic;
			rst : in std_logic;
			tobbi_led : out std_logic_vector(7 downto 0);
			d    : in std_logic_vector(3 downto 0) ;-- megjelentend szam: 0..F
         digit : out std_logic_vector(3 downto 0); -- digit engedlyezs aktv '0'
	      seg : out std_logic_vector(7 downto 0); -- szegmens meghajts aktv '0'
			seg_in : in std_logic_vector(2 downto 0)   --amit megadunk tolkapcsolval
		);
end dekad_kij;

architecture Behavioral of dekad_kij is
signal hertz_count : std_logic_vector(31 downto 0);
signal sec : std_logic :='1';
signal segm : std_logic_vector (7 downto 0);  -- a villog szegmens

begin

tobbi_led <=(others =>'0');

process (clk50,rst)
begin
if rst='1' then
	hertz_count <=(others =>'0');
   sec <='0';
elsif clk50'event and clk50 ='1' then
	hertz_count <=hertz_count + 1 ;
	
	if hertz_count = 50000000-1 then
		hertz_count <= (others => '0');
		sec <= not sec;		
	end if;
end if;


case seg_in is
	when "000" =>  segm <= sec & "0000000";
	when "001" =>  segm <= "0" & sec & "000000";
	when "010" =>  segm <= "00" & sec & "00000";
	when "011" =>  segm <= "000" & sec & "0000";
	when "100" =>  segm <= "0000" & sec & "000";
	when "101" =>  segm <= "00000" & sec & "00";
	when "110" =>  segm <= "000000" & sec & "0";
	when others => segm <= "0000000" & sec;
end case;
  
end process;

  
	
digit	 <= "1110";

 seg <=  "00000011" XOR segm when d = "0000" else
         "10011111" XOR segm when d = "0001" else
         "00100101" XOR segm when d = "0010" else
         "00001101" XOR segm when d = "0011" else
         "10011001" XOR segm when d = "0100" else
         "01001001" XOR segm when d = "0101" else
         "01000001" XOR segm when d = "0110" else
         "00011111" XOR segm when d = "0111" else
         "00000001" XOR segm when d = "1000" else
         "00011001" XOR segm when d = "1001" else	
			"00010001" XOR segm when d = "1010" else	
	      "11000001" XOR segm when d = "1011" else   
         "01100011" XOR segm when d = "1100" else  
         "10000101" XOR segm when d = "1101" else	
         "01100001" XOR segm when d = "1110" else  
         "01110001" XOR segm   ;				

end Behavioral;
