-- Ksztette : Vgh Tams 2006.11.15.
-- 
--Tervezzen egy egyszer szmll ramkrt, amely egy nyomgomb (BTN0) 
--megnyomsnak hatsra nvel egy 4 bites szmot.  
--A nyomgomb megnyomsi idejt mrni kell (min. 500 ms) s prellmentesteni kell.


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity fsm is
    Port ( clk50 : in std_logic;
             rst : in std_logic;
          uzenet : in std_logic_vector(1 downto 0); --a megnyomott gomb kdja 2-bl 1 kdban
             led : out std_logic;-- nyomgomb az egyik LED-en megjelenik direktben
		      szam : buffer std_logic_vector(3 downto 0)); -- kimeneti portvltoz,ami visszaolvashat
			
  TYPE allapotok IS (megnyomasra_var,elengedesre_var);

end fsm;

architecture Behavioral of fsm is
 signal stopper : std_logic_vector(31 downto 0);-- real time ra
 signal allapot: allapotok; -- automata (kijelzs ideje) (FSM) llapotvltozja

begin
process (clk50, rst)

begin
 if rst = '1' then --inicializls
   --aszinkron resetben alaphelyzetbe kell lltani a modul vltozit, ill. kimeneti portjait
                       stopper <= (others => '0') ;
                           led <= '0'  ;
	                       szam <= (others => '0')  ;
	                    allapot <= megnyomasra_var ;
	           elsif clk50'event and clk50 = '1' 
                        then -- f rajel felfut le van
                              if stopper < 5 * 50000000 then  
										      -- az idmrst 5 sec-nl lelltom (ez legyen nagyobb a max. mrend idnl
                                    stopper <= stopper +1;    -- hogy ne csorduljon tl az ra 
                              end if;

                            case allapot is --az llapottl fggen kell vizsglni az esemnyeket
                                --s vgrehajtani mveleteket ill. szksg szerint llapotvltst
										  
                              	when megnyomasra_var => 	
												 if uzenet = "01" then --gomb megnyoms esemny jelzs rkezett
												       led <= '1' ; --gy ltom a gomb megnyomst
												   stopper <= (others => '0') ;
								         	   allapot <=  elengedesre_var;
					                      end if;
	
	                              when elengedesre_var =>
				                         if uzenet = "10"  then ----gomb elengeds esemny jelzs rkezett
					                             led <= '0' ; --most engedtem el a gombot, a kijelzst ezrt kikapcsolom
					                             if (stopper >= 25000000) 
														      then --500 ms-nl hosszabb a gombnyoms hossza, elfogadom
							                               szam <= szam + 1; 
								                    end if;
							                       allapot <=  megnyomasra_var; --megyek a kvetkez gombnyomsra vrakoz llapotba
						       
						                   end if;
					 
	                              when others =>  null ;

                            end case ;
 
 end if ;

end process ;

end Behavioral;
